import { Token } from './token/token';
export declare class AbstractSyntaxTreeBase {
    private _value;
    private _leftNode;
    private _rightNode;
    private _parent;
    private _type;
    private _subType;
    value: Token.Token;
    readonly type: Token.Type;
    subType: Token.SubType;
    parent: this;
    leftNode: this;
    rightNode: this;
    constructor(value?: Token.Token);
    findRoot(): this;
    isRoot(): boolean;
    hasOpenBracket(): boolean;
    private findOpenedBracket();
    removeRootBracket(): this;
    removeClosestBracket(): this;
    private climbUp(token);
    private isClimbTop(token);
    private isTokenHighest(token);
    private createChildNode(value?);
    private createParentNode(value?);
    private insertOperatorNode(value);
    private needJointRight(rootNode, value);
    insertNode(value: Token.Token): this;
    private insertJointNodeToLeft(value);
    insertJointNodeToRight(value: Token.Token): this;
    removeLeftNode(): void;
    removeRightNode(): void;
    removeParent(): void;
}
